﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Drop_1(object sender, DragEventArgs e)
        {
            if (sender is TextBlock)
            {
                StackPanel sp = (sender as TextBlock).Parent as StackPanel;
                int tbIndex = sp.Children.IndexOf(sender as TextBlock);
                sp.Children.Insert(++tbIndex, new TextBlock() { Text = e.Data.GetData(DataFormats.StringFormat).ToString()});
                e.Handled = true;
            }
            else
                (sender as StackPanel).Children.Add(new TextBlock() { Text = e.Data.GetData(DataFormats.StringFormat).ToString() });
        }

        private void TextBlock_MouseMove(object sender, MouseEventArgs e)
        {
            TextBlock tb = sender as TextBlock;
            if (tb != null && e.LeftButton == MouseButtonState.Pressed)
            {
                DragDrop.DoDragDrop(tb,
                                     tb.Text,
                                     DragDropEffects.Copy);
            }
        }

        private void TextBlock_DragEnter(object sender, DragEventArgs e)
        {
            if (!((sender as TextBlock).Parent is StackPanel))
            {
                (sender as TextBlock).AllowDrop = false;
            }
        }
    }
}
